.
. Reconstructed source code of NOS/MT
.
.   Original code by John Walker / Dan Drake, ca. 1980
.   Disassembly tool by Peter Buro, 1986
.
          idt       "SCRIPT"
.
          copy      "../systemdef/sysdef"
          copy      "../source/jsys$"
.
SCRINP*   
          mov       r11,r10
lbl001    
          mov       uscrap(r7),r3             SCRIPT FILE ACTIVE?
          jeq       jlb000                      -> no

          mov       usterm(r7),r2             GET LINE BUFFER BLCOK
          mov       chibufe(r2),r1            match terminal line size
          s         chibuf(r2),r1
          mov       r1,r4
          ai        r1,mbtext                 add header size
          blwp      BGETA$                    allocate block
          data      MEMFUL  
          li        r0,mttext                 mark as text block
          mov       r0,mbtype(r1)
          mov       r1,r8                     save buffer ptr
          mov       r1,r5

          li        r1,28                     BUILD READ SCRIPT FILE REQUEST          
          blwp      BGETA$                    allocate buffer
          data      MEMFUL  
          mov       officode(r3),fmrqst(r1)   param 0 = file code
          mov       ofcpos(r3),fmrqst+2(r1)   param 1 = offset (h)
          mov       ofcpos+2(r3),fmrqst+4(r1) param 2 = offset (l)
          ai        r8,mbtext
          mov       r8,fmrqst+6(r1)           param 3 = text buffer ptr
          li        r0,SYSMB
          mov       r0,fmrqst+8(r1)           param 4 = memory bank
          mov       r4,fmrqst+10(r1)          param 5 = read length
          mov       r1,r8
          bl        FSBHEA                    fill out std FS request header
          li        r0,read$                  set jsys 'read'
          mov       r0,mbtype(r8)

          bl        FSEND                     SEND REQUEST AND PROCESS REPLY
          mov       frtext(r8),r2             get # of bytes read
          mov       frstat(r8),r0             get status
          mov       r8,r1                     release FS reply msg
          blwp      BREL$

          mov       r5,r8                     NEXT LINE AVAILABLE?
          mov       r0,r0                     success status from FS?
          jne       jlb001                      ->no, end script
          mov       r2,r2                     length read is zero?
          jeq       jlb001                      ->yes, end script
          mov       r8,r1
          ai        r1,mbtext
          cb        *r1,ch$eof                first character is ^D (eof)?
          jeq       jlb001                      ->yes, end script

          li        r0,1                      FIND LINE LENGTH
          mov       usterm(r7),r3
          mov       chiraw(r3),r4             reading in raw mode?
          jne       jlb002                      -> yes, length is one

jlb003    cb        *r1+,ch$eot              next char is ^Z (eot)?
          jeq       jlb002                      -> yes
          inc       r0                        increase length
          dec       r3                        [bug? r3 is not a counter?]                     
          jne       jlb003

jlb002    mov       r0,mblen(r8)              set line buffer length
          mov       uscrap(r7),r1             move offset by length
          a         r0,ofcpos+2(r1)
          jnc       jlb004  
          inc       ofcpos(r1)
jlb004    b         2(r10)                    NORMAL RETURN (= 'HAVE LINE')

jlb000    mov       *r10,r11                  TAKE 'NO SCRIPT' RETURN
          rt

jlb001    mov       r8,r1                     END SCRIPT
          blwp      BREL$                     release line buffer

          li        r1,18                     CLOSE SCRIPT FILE
          blwp      BGETA$                    build close FS message
          data      MEMFUL  
          mov       r1,r8
          mov       uscrap(r7),r2             param 0 = file code
          mov       officode(r2),fmrqst(r8)
          bl        FSBHEA                    fill out std FS request header
          li        r0,close$
          mov       r0,mbtype(r8)             set jsys 'close'
          bl        FSEND                     send msg to FS, wait for reply
          mov       r8,r1                     release FS msg
          blwp      BREL$

          mov       uscrap(r7),r1             MOVE TO NEXT SCRIPT (IF ANY)
          mov       scrlink(r1),uscrap(r7)    follow link (zero if none)
          dec       uscrac(r7)                decrease nesting depth
          blwp      BREL$                     release script control block

          b         lbl001                    TRY NEXT SCRIPT OR NONE

.
. scrtrm: close all script files on nesting chain
.
SCRTRM*   mov       r11,r10                   CLOSE ALL SCRIPT FILES

jlb006    mov       uscrap(r7),r3             script file active?
          jeq       jlb005                      -> no, done

          li        r1,18                     CLOSE TOP SCRIPT
          blwp      BGETA$                    allocate FS msg
          data      MEMFUL  
          mov       r1,r8
          mov       officode(r3),fmrqst(r8)   param 0 = file code
          bl        FSBHEA                    fill out std FS request header
          li        r0,close$
          mov       r0,mbtype(r8)             set jsys 'close'
          bl        FSEND                     send msg to FS, wait for reply
          mov       r8,r1                     release FS msg
          blwp      BREL$

          mov       uscrap(r7),r1             MOVE TO NEXT SCRIPT (IF ANY)
          mov       scrlink(r1),uscrap(r7)    follow link (zero if none)
          blwp      BREL$
          dec       uscrac(r7)                decrease nesting depth
          jmp       jlb006 

jlb005    b         *r10

ch$eof    byte      04
ch$eot    byte      0D
.
          end        
.
